/*!
 * vue-router-layout v0.1.0
 * https://github.com/ktsn/vue-router-layout
 *
 * @license
 * Copyright (c) 2018 katashin
 * Released under the MIT license
 * https://github.com/ktsn/vue-router-layout/blob/master/LICENSE
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
    (factory((global.VueRouterLayout = {}),global.Vue));
}(this, (function (exports,Vue) { 'use strict';

    Vue = Vue && Vue.hasOwnProperty('default') ? Vue['default'] : Vue;

    function createRouterLayout(resolve) {
        return Vue.extend({
            name: 'RouterLayout',
            data: function () {
                return {
                    layoutName: undefined,
                    layouts: Object.create(null)
                };
            },
            beforeRouteEnter: function (to, _from, next) {
                var reversed = to.matched.slice().reverse();
                var layoutName = 'default';
                for (var _i = 0, reversed_1 = reversed; _i < reversed_1.length; _i++) {
                    var record = reversed_1[_i];
                    var Component = record.components.default;
                    if (Component) {
                        var name_1 = typeof Component === 'function'
                            ? Component.options.layout
                            : Component.layout;
                        if (name_1) {
                            layoutName = name_1;
                            break;
                        }
                    }
                }
                next(function (vm) {
                    vm.layoutName = layoutName;
                    if (!vm.layouts[layoutName]) {
                        vm.$set(vm.layouts, layoutName, function () { return resolve(layoutName); });
                    }
                });
            },
            render: function (h) {
                var layout = this.layoutName && this.layouts[this.layoutName];
                if (!layout) {
                    return h();
                }
                return h(layout, {
                    key: this.layoutName
                });
            }
        });
    }

    exports.createRouterLayout = createRouterLayout;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
